# -*- coding: utf-8 -*-
from setuphelpers import *

try:
    import waptcrypto

    if "encrypted_data_str" in dir(waptcrypto):
        from waptcrypto import encrypted_data_str as rsa_encrypted_data_str
except:
    pass


import string
import random

users_to_change = [
    'root'
]


def install():
    # you can add you ssl certificate in the package in order to decrypt information in the audit_data
    for crt in glob.glob("*.crt"):
        filecopyto(crt, makepath(WAPT.wapt_base_dir, "ssl", crt))
    audit()


def audit():
    for user in users_to_change:
        all_passwords = list(WAPT.read_audit_data_set("laps", f"local_{user}_password"))
        if all_passwords:
            last_date = list(WAPT.read_audit_data_set("laps", f"local_{user}_password"))[-1][2]
        else:
            last_date = None
        if not last_date or (datetime.datetime.now() - isodate2datetime(last_date) > datetime.timedelta(days=365)) or force == True:
            randompassword = password_generator(size=20, chars=string.ascii_letters + string.digits)

            if not params.get("install_with_luti", False):
                run(r'usermod --password $(echo %s | openssl passwd -1 -stdin)  %s' % (randompassword, user))

            WAPT.write_audit_data_if_changed("laps", f"local_{user}_password", rsa_encrypted_data_str(randompassword, [WAPT.public_certs_dir]), max_count=3)
    return "OK"


def password_generator(size=20, chars=string.ascii_letters + string.digits):
    """
    Returns a string of random characters, useful in generating temporary
    passwords for automated password resets.

    size: default=8; override to provide smaller/larger passwords
    chars: default=A-Za-z0-9; override to provide more/less diversity

    Credit: Ignacio Vasquez-Abrams
    Source: http://stackoverflow.com/a/2257449
    """
    return "".join(random.choice(chars) for i in range(size))
